/* 19 feb 1998
SRE-http procedure  to access a "SWISH" index file.

         **  You MUST set the INDEX_DIR parameter  **

For usage details, see GOSWISH.DOC 

*/
/* ********************* User Changable Parameters ********** */

/* the default directory containing swish.exe, swish index files, etc. */

index_dir='\GOSERVE\SWISH'


/* how to display links to "other matches".  If all_sets=0, then
   just show link to prior and next set. If all_sets=1, then show
   numbers (1 2 3 ... ) linking to 1st, 2nd, etc. sets.   */
all_sets=1

/* *********************  End User Changable Parameters ********** */


swish_index_search:

parse arg  ddir, tempfile, reqstrg,list,verb ,uri,user, ,
          servdir ,tempdir,privset,enmadd,transaction,verbose, ,
          SERVERNAME, HOST_NICKNAME, HOMEDIR

/*
parse arg  ddir, tempfile, reqstrg,list,verb ,uri,user, servdir , ,
                 tempdir,privset,inistuff
parse var inistuff macrospace_input "," infiles
parse var infiles  a1 ',' a2 ',' virtual_file ',' .
*/


if verb="" then do
   say " This SRE-http add-on is NOT meant to be run from the command line."
   exit
end  /* Do */


if index_dir='' then index_dir=servdir
index_dir=strip(strip(index_dir),'t','/')
if dosdir(index_dir)=0 then do
   'String SRCHINDX error. No such index_dir: ' index_dir
   return 0
end /* do */

fii=value('SREF_PREFIX',,'os2environment')

/* Begin the result body.*/
tempdir=strip(translate(tempdir,'\','/'),'t','\')
TEMPOUT = systempfilename(TEMPDIR'\ST$?????.OUT')

if tempout = "0" | tempfile="" then do
     call lineout tempfile,'<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
     call lineout tempfile, "<html><head><title>Index search results </title></head>"
     call lineout tempfile,"<body> <STRONG> ERROR: Could not access working directory </STRONG>"
     call lineout tempfile," </BODY> </HTML> "
     call lineout tempfile
     oof=stream(tempfile,'c','query size')
     return 'FILE ERASE TYPE text/html NAME ' tempfile
end


keywords='help'
index_file="INDEX.SWI"
header_file=' '
footer_file=' '
descrip_file=' '
text_descrip_file=' '
descrip_file_type='STEM'

ndofiles=20
swopts=' '
isfilesearch=0          /* 0=ignore, 1= urlname search, 2=description search */
send_piece=1
aheader="Search the site-index "
ncmt=0 ; door=0
summary=1
exists=0
start=0
max_find=-1             /* if max_find=0, then search determine # matches */

if verb='GET' then 
  parse var uri newlist '?' list
else
  newlist=reqstrg

newlist=newlist||'?'

do until list="" 

  parse var list v1 '&' list ; oldv1=v1

  parse var v1 avar '=' aval ;
  avar=translate(packur(avar))
  aval=strip(strip(aval),,'"'); aval=packur(translate(aval,' ','+'))
  if abbrev(avar,"KEYWORD")=1 then  do
      keywords=packur(translate(aval,' ','+'))
  end
  if abbrev(avar,'HEADER')=1 then do
      aheader=packur(translate(aval,' ','+'))
  end
  if abbrev(avar,'HEADER_FILE')=1 then do
      header_file=packur(translate(aval,' ','+'))
      header_file=sref_do_virtual(index_dir,header_file,enmadd,0,transaction,HOMEDIR,HOST_NICKNAME)
  end

  if abbrev(avar,'START')=1 then do
       tt=translate(packur(translate(aval,' ','+')))
       parse var tt tt1 tt2
       if datatype(tt1)='NUM' then start=tt1
       if start<0 then start=0
       found_matches=tt2
       if datatype(tt2)='NUM' then max_find=tt2
       if datatype(max_find)<>'NUM' then max_find=-1
       oldv1=''         /* suppress it */
  end /* do */

  if abbrev(avav,'PIECE')=1 then do
     if aval=0 then send_piece=0
  end  /* Do */
  if abbrev(avar,'FOOTER_FILE')=1 then do
      footer_file=packur(translate(aval,' ','+'))
      footer_file=sref_do_virtual(index_dir,footer_file,enmadd,0,transaction,HOMEDIR,HOST_NICKNAME)
  end

  if abbrev(avar,'INDEX')=1 then do
     if pos(':',aval)>0 | abbrev(strip(aval),'\')=1 then do
          indxfile=strip(aval)
     end /* do */
     else do
       indxfile=sref_do_virtual(index_dir,aval,enmadd,0,transaction,HOMEDIR,HOST_NICKNAME)
     end
  end
  if abbrev(avar,'DESCRIP_FILE') then do
     if pos(':',aval)>0 | abbrev(strip(aval),'\')=1 then do
          descrip_file=strip(aval)
     end /* do */
     else do
        descrip_file=sref_do_virtual(index_dir,aval,enmadd,0,transaction,HOMEDIR,HOST_NICKNAME) 
     end
     descrip_file_type='STEM'
     if rxfuncquery('cvread')=1 then descrip_file=''   /*rexxlib is missing! */
  end
  if abbrev(avar,'TEXT_DESCRIP_FILE') then do
     if pos(':',aval)>0 | abbrev(strip(aval),'\')=1 then do
          descrip_file=strip(aval)
     end /* do */
     else do
        descrip_file=sref_do_virtual(index_dir,aval,enmadd,0,transaction,HOMEDIR,HOST_NICKNAME) 
     end
     descrip_file_type='TEXT'
  end

  if abbrev(avar,'COMMENT')=1 then do
      ncmt=ncmt+1
      comments.ncmt=translate(aval, ' ','+'||'00090d0a'x) 
  end
  if abbrev(avar,'COND')=1 then do
        select
         when abbrev(translate(aval),'Y')=1 then
               door=' OR '
         when abbrev(translate(aval),'O')=1 then
               door=' OR '
          when abbrev(translate(aval),'N')=1 then
                door=' NOT '
         otherwise
                door=0
        end
  end

  if abbrev(avar,'SUMMARY')=1 then do
        tt=translate(aval)

        summary=1
        if tt="NO" then
           summary=1
        if tt="YES" | tt=1 then
           summary=2
        if tt="CREATE"| tt=2 then
           summary=3
  end

  if abbrev(avar,'EXISTS')=1 then do
        tt=translate(aval)
        if wordpos(translate(tt),'YES Y 1')>0 then
           exists=1
        else
           exists=0
  end

  if abbrev(avar,'OPTION')=1 then do
      aval=strip(translate(aval,' ','+'))
      select
         when abbrev(translate(aval),'FILE')=1 then
            isfilesearch=1      /* filename */
         when abbrev(translate(aval),'SUMMARY')=1 then
            isfilesearch=2      /* summary */
         otherwise
            swopts=swopts||" "||aval
      end
      if abbrev(translate(aval),'-m')=1 then
           parse arg aval . ndofiles
  end
  if oldv1<>'' then newlist=newlist||oldv1||'&'

end             /* Options parsing */
newlist=strip(newlist,'t','&')


/* load "Description cache"? */
dcache.0=0
if  descrip_file<>' ' then do
   foo=stream(descrip_file,'c','query exists')
   if foo<>' ' then do
       if descrip_file_type='STEM' then do
          a=cvread(descrip_file,dcache)
       end
       else do          /*text type (i.e.; from mkswish */
          div=' &^%^& ' 
          div2=' #$*~~#$* '
          goofy=charin(descrip_file,1,chars(descrip_file))
          foo=stream(descrip_file,'c','close')
          ii=0 ;dcache.0=0
          do  until goofy=''
              parse var goofy aa (div2) goofy
              ii=ii+1 ; dcache.0=ii
              parse var aa dcache.ii.!gotit (div) dcache.ii (div) dcache.ii.!title (div) ,
                           dcache.ii.!size (div) dcache.ii.!yes
              dcache.ii.!create=dcache.ii.!yes
          end                   /* read lines from descirpfile */
      end               /* text type */
   end                   /* descrip file exisst */

   do mm=1 to dcache.0
       dcachel.mm=dcache.mm
   end /* do */
   dcachel.0=translate(dcache.0)
end  /* Do */

parse var swopts p1 '-m' TOFIND p2
IF TOFIND="" then TOFIND=40                     /* THE DEFAULT */
if start>0 then do              /* adjust the -m option */
   MMX=TOFIND+START-1
   if max_find=0 then  mmx=1000      /* ASSUME THAT'S THE MOST YOU'LL EVER WANT TO FIND */
   swopts=p1||' -m '||mmx||' '||p2
end /* do */

if datatype(ndofiles)<>'NUM' then ndofiles=20

/* if filesearch and no descriple, error */
if isfilesearch>0 & dcache.0=0 then do
  call lineout tempfile,'<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
  call lineout tempfile, "<html><head><title>Index search results </title></head>"
  call lineout tempfile," <STRONG>Sorry</strong> FileSearch requires a description file.  </BODY> </HTML> "
  call lineout tempfile
  oof=stream(tempfile,'c','query size')

  return 'FILE ERASE TYPE text/html NAME ' tempfile
end  /* Do */

/* adjust # to find, given  */


/* send in pieces ? */
if send_piece=1 then do
          'SET NETBUFFER OFF '
  if fii<>'' then
        foo=sref_multi_send('','text/html','1S')
  else
        'SEND TYPE text/html as INDXSRCH '
end

crlf='0d0a'x
aa=""
aa=aa|| '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
aa=aa|| "<html><head><title>Index search results </title>"
aa=aa||"</head>"
call dumpit(aa)


/* write the header -- use HEADER and COMMENTS, or use HEADER_FILE */
ahead.0=0
if header_file<>' ' then do
   wow=afileread(header_file,ahead,,'E')
   do ww=1 to wow
      ahead.ww=ffread.ww
   end /* do */
   ahead.0=wow

   if wow=0 & verbose>0 then say " Warning: SRCHINDX header file missing: " header_file
end  /* Do */
if ahead.0=0 then do 
   aa='<body> <h1> ' aheader ' </h1> 'crlf
end
else do   /* NOTE: the headerfile MUST contain a <body> element */
    aa=""
    do ll=1 to ahead.0
        aa=aa||ahead.ll||crlf
    end
end
call dumpit(aa)

/* write out comments */
aa=""
do mm=1 to ncmt
   aa=aa||' <em> ' comments.mm ' </em> <br>'crlf
end
call dumpit(aa)

/* fix up keyword list */
twords=translate(keywords) ; srchwords=""
/* remove silly srchwords */
do mm=1 to words(twords)
   aword=word(twords,mm)
   if wordpos(aword,'AND NOT OR')>0 then iterate
   srchwords=srchwords||" "||aword
end

if door<>0 & words(keywords)>1 then do   /* insert not / or  into keyword list */
   tmp=word(keywords,1) ; wasand=0
   do mmm=2 to words(keywords)
      aww=word(keywords,mmm) ; taw=strip(translate(aww))
      if wasand=1 then do
        tmp=tmp||' '||aww
        wasand=0
        iterate
      end
      if taw="OR"| taw="AND" | taw="NOT"then do
        tmp=tmp||' '||aww
        wasand=1
        iterate
      end
      tmp=tmp||door||aww
    end
    keywords=tmp
end

if isfilesearch=0 then do
   if stream(indxfile,'c','query exists')="" then do
      aa=" <p><b>Sorry</b>, the requested search index does not exist (" indxfile ")  </BODY> </HTML> "
      call dumpit(aa)
      rmessage=' Error in SRCHINDX: No .SWI file: 'indxfile
      signal sendher
   end
   t1='swish -f '||INDXfile ||' -w '||keywords||' '||swopts||' > '||tempout
   foodir=directory(index_dir)
   address cmd
    t1
   address
   foodir=directory(foodir)

/* get results */
   gotem=afileread(tempout,'filelines',,'e')
   do iij=1 to gotem
      filelines.iij=ffread.iij
   end /* do */
   filelines.0=gotem
   goo=sysfiledelete(tempout)
end
else do         /* search filenames in */
  gotem=do_fsearch(isfilesearch,keywords,ndofiles)  /* one of the cache search variants */
end

/* --- sample to test remote url retrieval
foo=filelines.gotem
filelines.gotem='100 http://www.yahoo.com "THis is yahoo " 1 '
gotem=gotem+1
filelines.gotem=foo
---------- */

if gotem=0 then do
    aa=" <p><STRONG> No matches found </STRONG> </BODY> </HTML> "
    if  send_piece=0 then do
        call lineout tempfile,aa
        call lineout tempfile
        oof=stream(tempfile,'c','query size')
        return 'FILE ERASE TYPE text/html NAME ' tempfile
    end
    else do
       if fii<>'' then do         /* 1.3 */
            foo=sref_multi_send(aa,,'1E')
       end /* do */
       else do
         'var name aa '
         'send complete'
       end
    end  /* Do */
    oof=extract('bytessent')
    return  '200 '||oof||' problem in srchindx'
end

igot=0 ; nfound=0
if start=0 then start=1

do mm=1 to gotem

   RLINE = filelines.mm
   IF RLINE = '' THEN leave
   IF RLINE = '.' THEN leave


/* Skip comment lines and empty lines. */
   IF abbrev(RLINE,'#') = 1  THEN iterate

/* Split the line into fields. */
    PARSE VAR RLINE R_SCORE R_FILE R_stuff
    foo1=words(r_stuff)
    r_title=delword(r_stuff,foo1)
    r_position=word(r_stuff,foo1)

/* Make sure this looks valid (i.e. that position and score are both 
   numeric variables).                                               */

  IF VERIFY(R_SCORE, '1234567890') <> 0 | VERIFY(R_POSITION, '1234567890') <> 0 THEN  do
       aa=strip(rline)
       if abbrev(translate(aa),'SEARCH WORDS:') then do
            bb='<p><strong> Searching for: </strong> 'crlf
            parse var rline foo ':' lookme
            bb=bb||' <code> ' lookme '</code>'
            call dumpit(bb)
       end
       if abbrev(translate(aa),'# COUNTS') then do
           parse var aa . ':' jwords . ',' jfiles .
           bb='<p><em>The index contains 'jwords 'words from ' jfiles ' files.</em>'
           call dumpit(bb)
       end /* do */
       iterate
  end

/* got a legit match */
  igot=igot+1
  if igot=1 & max_find=0 then do      /* determine max_find */
     max_find=(gotem-mm)  /* last line is a . */
  end /* do */

  if igot<start then iterate

  if igot=start then do
        aa='<h3> Results of search </h3>  <dl>'
        call dumpit(aa)
   end

/* Spit out this reference as a HTML link. */
  r_file=translate(r_file,'/','\')
  r_title=strip(strip(r_title),,'"')
  if r_title="" then do 
      tmp2=translate(r_file,' ','\/'); r_title=word(tmp2,words(tmp2))
  end /* do */
  aa2='<dt> <A href=' r_file '>' r_title '</a>'crlf

  aa='&#32; <em> Score= ' r_score ' </em> 'crlf
  aa=aa||' <code> , ' r_position 'bytes </code> <br>'crlf
  if summary>1 | exists>0 then do
     foo=make_summary(aa,r_title,r_file,summary,srchwords,exists)
  end
  else do
     call dumpit(aa2||aa)
  end /* do */

  nfound=nfound+1
  IF IGOT>=(START+TOFIND-1) then leave
end

if igot>=start then call dumpit('</dl>')

select 
  when igot=0 then
     call dumpit('<p><em>No matches. </em> ')
  when nfound=0 then
     call dumpit('<p> <em> Number of matches less then requested starting match (at # 'start') </em>')
   when nfound<tofind & start=1  then
        call dumpit("<p> <em> Total of " igot " matches </em>")
   otherwise do
      if max_find>0 then 
        call dumpit("<p> <em> Displaying " (1+igot-start) "  of " MAX_FIND" total matches (starting from match # "start ") </em>")
      else
        call dumpit("<p> <em> Displaying " (1+igot-start) " matches (starting from match # "start ") </em>")
  end
end


if max_find>0 then do           /* set up links to next/prior matches */
   call dumpit('<br>')
   if all_sets<>1 then
      call show_prior_next
   else
      call show_all_sets
end /* do */

call dumpit('<p>')

if footer_file<>' ' then do             /*write a footer file */
   foo=afileread(footer_file,afoot,,'E')
   do iij=1 to foo
      afoot.iij=ffread.iij
   end /* do */
   afoot.0=foo

   if foo=0 & verbose>0 then say " Warning: SRCHINDX header file missing: " header_file
   do mm=1 to afoot.0
      call dumpit(afoot.mm)
   end /* do */
end  /* Do */

rmessage='SRCHINDX completed '

sendher: nop
if send_piece=0 then do
   call lineout tempfile,'</body></html>'
   call lineout tempfile
   oof=stream(tempfile,'c','query size')
   return 'FILE ERASE TYPE text/html NAME ' tempfile
end
else do
  aa='</body></html> '
  if fii<>'' then do         /* 1.3 */
      foo=sref_multi_send(aa,,'1E')
   end /* do */
   else do
      'var name aa '
      'send complete'
   end
end  /* Do */
aa=extract('bytessent')
return '200 '||' '||aa||' '||rmessage



/**************************/
/* links to sets of matches */
show_all_sets:
call dumpit('<br><tt>Other matches:</em>&nbsp;')
glen=0
do mj1=1 to max_find by tofind
  newlist1=newlist||'&START='||mj1||'+'||max_find
  call dumpit('<a href="'||newlist1||'">' mj1'</a> &nbsp;&nbsp; ')
  glen=glen+1
end /* do */

return 1

/**************************/
/* links to prior & next matches */
show_prior_next:

   if igot>tofind then do       /* setup link for prior TOFIND */
        j1=start-tofind
        newlist1=newlist||'&START='||j1||'+'||max_find
        call dumpit('<a href="'||newlist1||'">Prior' tofind ' matches </a> ')
   end
   if igot<max_find then do   /* set up link for next TOFIND */
        j1=start+nfound
        newlist1=newlist||'&START='||j1||'+'||max_find
        eef=' '
        if igot>tofind then eef=' || '
        call dumpit(eef' <a href="'||newlist1||'"> Next' tofind ' matches </a> ')
   end /* do */
return 1

/*******************/
/* write to tempfile, or VAR it */
dumpit:
parse arg aa
crlf='0d0a'x

if send_piece=0 then do
  call lineout tempfile,aa
end
else do
    aa=aa||crlf
    if fii<>'' then          /* 1.3 */
       foo=sref_multi_send(aa)
    else
       'var name aa '

end
return 0


/************/
/* read file into ffread stem var */
afileread:procedure expose ffread. fii
parse arg hfile
crlf='0d0a'x
if stream(hfile,'c','query exists')="" then return 0
tmp=strip(charin(hfile,1,chars(hfile)),'t','1a'x)
tt=stream(hfile,'c','close')
itmp=0
do until tmp=""
   itmp=itmp+1
   parse var tmp ffread.itmp (crlf) tmp
end /* do */
ffread.0=itmp
return itmp 



/***********************************/
/* search files names, etc instead of keyword index 
dcache.  contains cache index 
dcachel. just the urls (for searching in)
filelines. return these to be displayed
isfilesearch: 0= normal keywords, 1=search files, 2=search summarys
keywords: keywords to search for (and highlight)
ndofiles: max matches to display
*/
do_fsearch:procedure expose dcache. dcachel. filelines. fii

  parse arg  isfilesearch,keywords,ndofiles
 keywords='OR '||translate(strip(keywords))
/* seperate out OR AND and NOT keywords. Default is AND (first
one is OR) */
alist.1=' ' ; alist.2=' ' ; alist.3=' ';ismod=1
do mm=1 to words(keywords)
   aw=strip(word(keywords,mm))
   oop= wordpos(aw,'OR AND NOT')
   if oop=0 then do
        alist.ismod=alist.ismod||' '||aw
        ismod=2                 /* reset to AND */
   end
   else do
        ismod=oop
   end  /* Do */
end /* do */

oof=keywords
if strip(translate(word(keywords,1)))="OR" then oof=subword(keywords,2)

if isfilesearch=1 then
   bb='<p><strong> Searching file names for: </strong><code> 'oof||'</code>'||'0d0a'x
else
   bb='<p><strong> Searching <em>summaries </em> for: </strong><code> 'oof||'</code>'||'0d0a'x

 call dumpit(bb)

ors=alist.1 ; ors.0=0
if ors<>' ' then ors.0=words(ors)
ands=alist.2 ; ands.0=0
if ands<>' ' then ands.0=words(ands)
nots=alist.3 ; nots.0=0
if nots<>' ' then nots.0=words(nots)

/* check each line for ors, ands, and nots */
do mm=1 to dcache.0
   isok.mm=0            /* assume faiulre */
 
   if isfilesearch=1 then
        aurl=strip(translate(dcachel.mm))
   else
        aurl=strip(translate(dcache.mm.!create))

/* if it's a not, failure */
   do mm2=1 to nots.0
      if pos(strip(word(nots,mm2)),aurl)>0 then iterate mm
   end
/* all and's have to be there */
    do mm2=1 to ands.0
        if pos(strip(word(ands,mm2)),aurl)=0 then iterate mm
    end /* do */
/*any of the ors */
   isok.mm=1           
   if ors.0=0  then iterate   /* >0 ors, 1 must be fulfilled */
   do mm2=1 to ors.0
      jj=strip(word(ors,mm2)) 
      if  pos(jj,aurl)>0 then iterate mm /* success*/
   end /* do */
   isok.mm=0             /* did not match an ors */
end /* do */

/* if isok=1, then this is a match. Return the first ndo matches in
the filelines. stem variable. Filelines. should contain:
 score url title position:
score=100 (that is, no score)
url=dcache.n
title=dcache.n.!title
bytes=title.n.!size
*/
noks=0
do mm=1 to dcache.0
   if isok.mm=1 then do
       noks=noks+1
       atitle=dcache.mm.!title ; if atitle="" then atitle=dcache.mm
       filelines.noks='100 ' dcache.mm ' ' atitle ' ' dcache.mm.!size
   end  /* Do */
   if noks>ndofiles then leave
end /* do */
filelines.0=noks

return noks
 

/* ---------------------------------------------------------------------- */
/* write summary info
Asummary:  2=explicit, 3=create
acheck:1=check on existence of file or url
*/

make_summary:procedure expose tempfile ddir enmadd transaction  dcache. dcachel. send_piece fii
gmess.1=' File not available'
gmess.2=' Summary not available'
gmess.3=' Explicit summary not available'
gmess.4=' Error in routine -- no summary available'


parse arg aa,a_title,aurl,asummary, srchwords,acheck
crlf='0a0d'x

aayes='<dt> <A href=' aurl '>' a_title '</a>'crlf
aano='<dt> <u>' a_title '</u>'crlf

ishttp=abbrev(strip(translate(aurl)),"HTTP://") /* file, or url? */

/* if acheck=1, then check on existence of file, or of url */
if acheck=1 then do
  if ishttp=0 then do
    afilenam=sref_do_virtual(ddir,aurl,enmadd,0,transaction,HOMEDIR,HOST_NICKNAME)
    if afilenam<>"" then afilenam=stream(afilenam,'c','query exists')
    if afilename="" then
       call dumpit(aano||aa)
    else
       call dumpit(aayes||aa)
    
  end
  else do               /* use HEAD request for url */
     stuff=sref_head_url(aurl)
     if stuff=0 then
       call dumpit(aano||aa)
     else
       call dumpit(aayes||aa)
  end /* do */
end
else do         /* no check, assume it exists */
       call dumpit(aayes||aa)
end

if asummary<2  then return 0            /* no summary, so return */

/* try and find/create a summary */

/* note: .!gotit values:  0-none, 1=created, 2=explicit */
aurl=translate(aurl)
if dcache.0>0  & asummary>1 then do           /* cache exists: Use it! */
   gotit=0
   do mm=1 to dcachel.0
       if dcachel.mm=aurl then do
                gotit=mm ; leave
       end /* do */
   end /* do */
   if gotit=0 then do
       call dumpit(' <dd> <code> Summary not available </code> ')
       return 0
    end
   ii=gotit  
   if asummary=2 then 
        dathing=strip(dcache.ii.!yes)
   else
        dathing=strip(dcache.ii.!create)
   if datatype(dathing)="NUM" then do   /* replace special codes */
        if dathing>0 & dathing<5 then dathing=gmess.dathing
   end  /* Do */
   if dcache.ii.!gotit=0 then do        /* no match signal */
      call dumpit('<dd> <code> '|| dathing|| ' </code> ')
      return 0
   end  /* Do */
   wow=space(translate(dathing,' ','00090a0d1a1b'x))    /* cleanup selection */
    do jmm=1 to words(srchwords)
         aword=strip(word(srchwords,jmm))
         wow=sref_make_block(aword,wow,'<b>','</b>')   /* highlight matches */
     end
 
     if  dcache.ii.!gotit=1 then 
          aa='<dd>  <code> ' wow ' </code>'
     else
          aa='<dd>   ' wow
     call dumpit(aa)
     return 0
end  /* CACHED description file */

atype=translate(sref_mediatype(aurl))  /* get mime type */

/* strip out http://a.b.c/ */

if ishttp=0 then do

  if afilenam="" then do
     call dumpit('<dd> <code> No summary available </code> ')
     return 0
  end

  eek=sysfiletree(afilenam,'aflist','F')   /* check for existence*/
  if eek<>0 | aflist.0=0 then do            /* error */
      call dumpit('<dd> <code> Summary not available </code> ')
      return 0
  end

end

/* text/plain summary ... */
if atype="TEXT/PLAIN" then do

   if asummary=2 then do  /* text/plain can not have explicit */
     call dumpit('<dd> <code> Summary not available </code> ')
     return 0
   end
  
 /* asummary must be 3  -- create */
    if ishttp=1 then do
        stuff=Sref_get_url(aurl,500)
        if length(stuff)>500 then stuff=left(stuff,500)
        else
        if stuff=0 then do
           call dumpit('<dd> <code> Summary not available </code> ')
           return 0
        end
    end
    else do
       filename=aflist.1
       filename=strip(word(aflist.1,words(aflist.1)))
       alen=min(chars(filename),500)
       stuff=charin(filename,1,alen)
    end

    wow=space(translate(stuff,' ','00090a0d1a1b'x))
    wow=sref_replacestrg(wow,'<','&lt;','ALL')
    wow=sref_replacestrg(wow,'>','&gt;','ALL')
    wow=sref_replacestrg(wow,'"','&quot;','ALL')
    wow=sref_replacestrg(wow,'&','&amp;','ALL')
    do jmm=1 to words(srchwords)
         aword=strip(word(srchwords,jmm))
         wow=sref_make_block(aword,wow,'<b>','</b>')   /* highlight matches */
     end
    call dumpit('<dd>   '|| wow)
    return 0
end

/* if not html (and not text/plain), return no summary*/
if atype<>"TEXT/HTML"  then do
     call dumpit('<dd> <code> Summary not available </code> ')
   return 0
end


/* if here--  html*/
/* and the url points to a legit file; read it in (up to 10000 characters */

if ishttp=1 then do
        stuff=sref_get_url(aurl,10000)
        if stuff=0 then do
           call dumpit('<dd> <code> Summary not available </code> ')
           return 0
        end
end
else do
   filename=aflist.1
   filename=strip(word(aflist.1,words(aflist.1)))
   alen=min(chars(filename),10000)
   stuff=charin(filename,1,alen)
end

stuff=space(translate(stuff,' ','00090a0d1a1b'x))
url_title=0

wow=look_header(filename)

if wow<>0 then do
  do jmm=1 to words(srchwords)
      aword=strip(word(srchwords,jmm))
      wow=sref_make_block(aword,wow,'<b>','</b>')   /* highlight matches */
  end
  call dumpit('<dd> '|| wow)
  return 0
end
if asummary<>3 then do           /* return if not CREATE */
   call dumpit('<dd> <code> Explicit summary not available</code> ')
   return 0
end

WOW=LOOK_HTAG()
if wow<>0 then do

  do jmm=1 to words(srchwords)
      aword=strip(word(srchwords,jmm))
      wow=sref_make_block(aword,wow,'<b>','</b>')   /* highlight matches */
  end
  call dumpit('<dd> <code>'||  wow ||' </code>')
  return 0
end

if url_title<>0 then
   aa='<dd> <code> ' url_title ' </code> '
else
   aa='<dd> <code> Summary not available </code> '
call dumpit(aa)
return 0



/* ----------------------------------------------------------------------- */
/* Look for "desc" field in header     */
/* ----------------------------------------------------------------------- */

look_header: procedure expose stuff url_title fii
parse arg afile
dowrite=0
do until stuff=""

    parse var stuff  p1 '<' tag '>' stuff
    if  translate(word(tag,1))="HEAD" then do   /* now in head !*/
            dowrite=1
            iterate
    end
    if dowrite=0 then iterate    /* wait till we get into head .. */

    if  translate(word(tag,1))="/HEAD" then  /* out of head, all done ! */
        leave

/* IT IS A TITLE TAG?  */
     if translate(word(tag,1))="TITLE" then do
        parse var stuff url_title '<' footag '>' stuff
     end

/* is it a  META HTTP-EQUIV or a META NAME ? */
    if translate(word(tag,1))="META" then do
        parse var tag ameta atype '=' rest
        tatype=translate(atype)
        if tatype="HTTP-EQUIV" | tatype="NAME" then do
           parse var rest aval1 rest
           REST=STRIP(REST)

           aval1=strip(aval1) ;
           aval1=strip(aval1,,'"')
           if abbrev(translate(aval1),'DESC')<>1 then iterate

           aval2=" "
           foo1=ABBREV(translate(rest),'CONTENT')
           if foo1>0 then do
                PARSE VAR REST FOO '=' AVAL2
                aval2=strip(aval2)
                aval2=strip(aval2,'b','"')
                WOW=LEFT(AVAL2,500)
                wow=sref_replacestrg(wow,'<','&lt;','ALL')
                wow=sref_replacestrg(wow,'>','&gt;','ALL')
                return WOW
           end
        end             /* name or http-equiv */
    end         /* meta */
end             /* stuff */

if stuff="" then say "Warning: </head> tag NOT found: " afile

return 0


/* ----------------------------------------------------------------------- */
/* Extract <hn> fields     */
/* ----------------------------------------------------------------------- */

look_htag: procedure expose stuff filename fii

stuff0=left(stuff,1000)

amessage=""
dowrite=0
do until stuff=""
    parse var stuff  p1 '<' tag '>' stuff
    ttag=translate(word(tag,1))
    if wordpos(ttag,' H1 H2 H3 H4 TITLE')>0 THEN DO   /* grab stuff */
        parse var stuff  amess '<' tag2 '>' stuff
        amessage=amessage||amess||'<b> | </b>'
    end
end

if amessage="" then do  /* getting desperate -- grab any old words! */
   do until stuff0=""
      parse var stuff0 p1 '<' tag '>' stuff0
      amessage=amessage||' '||p1
   end
end

if amessage="" then
   return 0
amessage=left(amessage,300)  /* keep it short */
return amessage




/* do a head request */
sref_head_url:procedure expose fii
parse arg aurl,verbose
crlf='0d0a'x

got=""
aurl=sref_fix_url(aurl)
if abbrev(translate(aurl),'HTTP://')=1 then do
   aurl=substr(aurl,8)
end
parse var aurl server '/' request

family  ='AF_INET'
httpport=80

rc=sockgethostbyname(server, "serv.0")  /* get dotaddress of server */
if rc=0 then do;  return 0; end

dotserver=serv.0addr                    /* .. */

gosaddr.0family=family                  /* set up address */
gosaddr.0port  =httpport
gosaddr.0addr  =dotserver

gosock = SockSocket(family, "SOCK_STREAM", "IPPROTO_TCP")

request=strip(request,'l','/')
message='HEAD /'request' HTTP/1.0'crlf'HOST:'server||crlf

message=message||crlf
got=''
rc = SockConnect(gosock,"gosaddr.0")
if rc<0 then do;  return 0 ; end
rc = SockSend(gosock, message)
/* Now wait for the response */
do r=1 by 1
  rc = SockRecv(gosock, "response", 1000)
  got=got||response
  if rc<=0 then leave
  end r
rc = SockClose(gosock)

parse var  got aa (crlf) .
parse var aa a1 a2 a3
if a2>=300 then return 0
return 1

